'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactDom = require('react-dom');

var _reactDom2 = _interopRequireDefault(_reactDom);

var _throttle = require('lodash/throttle');

var _throttle2 = _interopRequireDefault(_throttle);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var ScrollView = function (_Component) {
  _inherits(ScrollView, _Component);

  function ScrollView() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, ScrollView);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = ScrollView.__proto__ || Object.getPrototypeOf(ScrollView)).call.apply(_ref, [this].concat(args))), _this), _this.onWheel = function (e) {
      if (_this._tick) return false;
      requestAnimationFrame(function () {
        _this._tick = true;
        _this.update(e);
      });
    }, _this.componentDidMount = function () {
      _this.update();
      _this.scrollTop = _this.wrapper.scrollTop;
    }, _this.update = function (e) {
      _this._tick = false;
      var scrollTop = _this.wrapper.scrollTop;
      var wrapperHeight = _this.wrapper.offsetHeight;
      var childHeight = _reactDom2.default.findDOMNode(_this.child).offsetHeight;
      if (_this.scrollTop !== scrollTop && scrollTop + wrapperHeight > childHeight - 200) {
        _this.props.onEndReached();
      }
      _this.scrollTop = scrollTop;
    }, _this._tick = false, _this.refWrapper = function (ref) {
      return _this.wrapper = ref;
    }, _this.refChild = function (ref) {
      return _this.child = ref;
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(ScrollView, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          _props$style = _props.style,
          style = _props$style === undefined ? {} : _props$style,
          children = _props.children,
          width = _props.width;

      var clonedChildren = _react2.default.cloneElement(children({
        width: width,
        scrollTop: this.scrollTop
      }), { ref: this.refChild });
      return _react2.default.createElement(
        'div',
        {
          ref: this.refWrapper,
          onWheel: this.onWheel,
          onScroll: this.onWheel,
          style: Object.assign({ overflowY: 'auto' }, style)
        },
        clonedChildren
      );
    }
  }]);

  return ScrollView;
}(_react.Component);

ScrollView.defaultProps = {
  onEndReached: function onEndReached() {}
};
exports.default = ScrollView;